com.corticon.eclipse.core.util

## Class CcUtil

- java.lang.Object
- - com.corticon.eclipse.core.util.CcUtil

-     public class CcUtil
      extends java.lang.Object

  CcUtil is a general-purpose "Swiss Army Knife" class with helpful static methods.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `CLASS_NAME_ARRAY_PREFIX`
    `static java.lang.String` | `CLASS_NAME_ARRAY_SUFFIX`
    `static java.util.List` | `LOGICAL_ELEMENTS_LIST`
    `static java.util.List` | `NOT_REQUIRED_QUOTED_RESOURCES`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CcUtil()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static org.jdom.Element` | `addChild(org.jdom.Element aParent, java.lang.String aName)`
    `static org.jdom.Element` | `addChild(org.jdom.Element aParent, java.lang.String aName, java.lang.String aValue)`
    `static org.jdom.Element` | `addChild(org.jdom.Element aParent, java.lang.String aNodeName, java.lang.String aAttributeName, java.lang.String aAttributeValue)`
    `static int` | `calculateOverlap(int aiBeginOne, int aiEndOne, int aiBeginTwo, int aiEndTwo)` Calculate the overlap between two ranges of values.
    `static java.lang.String` | `capitalize(java.lang.String astrString)` Trim and capitalize a string (i.e., make the first character uppercase).
    `static org.eclipse.emf.ecore.EObject` | `cloneEObject(org.eclipse.emf.ecore.EObject aEObject, boolean abUnresolve)` Create a deep clone of the specified EMF object.
    `static boolean` | `containsAllowableCharacters(java.lang.String astrString, java.lang.String astrCharactersAllowable)` Determine whether the specified string contains allowable characters
    `static boolean` | `containsBlanks(java.lang.String astrString)` Determine whether the specified string contains any blanks.
    `static java.lang.String` | `convertEscapeToSpace(java.lang.String astrInput)` Convert Java escape characters such as carriage return and line feed to spaces.
    `static java.lang.String` | `convertFileURIToFilePath(java.lang.String lstrResult)` Convert file URI to file path, e.g.
    `static java.lang.String` | `convertPathToRelative(java.lang.String astrPathInput)` Convert the specified absolute path to Eclipse workspace-relative.
    `static java.lang.String` | `convertPlatformURIToFilePath(java.lang.String astrURI)` Convert platform URI to file path, e.g.
    `static java.lang.String` | `convertValueSetToString(java.lang.Object aObject)` Convert a ValueSet instance to a string in set notation.
    `static ValueSet` | `createValueSetFromString(java.lang.String astrInput)` Create a new instance of ValueSet from a string in set notation.
    `static void` | `debugStackTrace()` Handy method to generate a stack trace.
    `static java.lang.String` | `decapitalize(java.lang.String astrString)` Trim and decapitalize a string (i.e., make the first character lowercase).
    `static java.lang.String` | `determineCommonRoot(java.util.List<java.lang.String> alstFilePaths)`
    `static java.lang.String` | `escapeUnicodeString(java.lang.String astrInput, boolean abEscapeAscii)` Given a Unicode string, display the hexadecimal Unicode values.
    `static java.lang.String` | `exceptionToString(java.lang.Throwable aThrowable)` Convert an exception or error stack trace to string form.
    `static boolean` | `exists(org.eclipse.emf.ecore.EObject aEObject)` Does this EObject exist with given URI?
    `static boolean` | `exists(org.eclipse.emf.common.util.URI aURI)` Does object pointed to by the URI exist?
    `static org.eclipse.core.resources.IResource` | `findResource(org.eclipse.emf.ecore.EObject aEObject)` Retrieve the Eclipse platform Resource (IResource) corresponding to the specified EMF object.
    `static org.eclipse.core.resources.IResource` | `findResource(org.eclipse.emf.common.util.URI aURI)` Find resource in workspace given a URI.
    `static java.lang.String` | `formatCustomDataType(java.lang.String astrCustomDataTypeName, java.lang.String astrEnumerationLabel)` Format and return a custom data type reference given a name and enumeration label
    `static java.lang.String` | `formatValueSetString(java.lang.String astrSet, java.util.Locale aLocale, boolean abAvoidQuotingKeywords)` Given a caller-supplied set in standard notation, add apostrophes (single quotes) if necessary.
    `static java.lang.String` | `fromDateToString(java.util.Date aDate)`
    `static java.lang.String` | `generateHibernateUserFriendlyExceptionMessage(java.lang.Throwable aThrowable)`
    `static java.lang.String` | `getArrayClass(java.lang.String astrClassNameArray)` Returns the "real" class name of an array class without the array prefix and suffix.
    `static java.lang.String` | `getBaseRuleID(java.lang.String astrRuleId, java.util.Locale aLocale)` Given a localized Rule ID expressed in a particular locale, return the corresponding base ID.
    `static boolean` | `getBooleanFromProperties(java.lang.String astrPropertyName, boolean abDefault)` Get the specified boolean property.
    `static java.lang.String` | `getCustomDataTypeEnumerationLabel(java.lang.String astrCustomDataTypeReference)` Given a custom data type reference (e.g., "ShirtSize#Small"), return the enumeration label portion (e.g., "Small").
    `static java.lang.String` | `getCustomDataTypeName(java.lang.String astrCustomDataTypeReference)` Given a custom data type reference (e.g., "ShirtSize#Small"), return the custom data type portion (e.g., "ShirtSize").
    `static java.lang.String` | `getDatabaseCatalogName(java.lang.String astrFullyQualifiedTableName)` Given fully-qualified table name, return the catalog name.
    `static java.lang.String` | `getDatabaseFullyQualifiedName(java.lang.String astrCatalog, java.lang.String astrSchema, java.lang.String astrTable)` Return a fully-qualified database table name given optional catalog, schema and table name.
    `static java.lang.String` | `getDatabaseSchemaName(java.lang.String astrFullyQualifiedTableName)` Given fully-qualified table name, return the schema name.
    `static java.lang.String` | `getDatabaseTableName(java.lang.String astrFullyQualifiedTableName)` Given fully-qualified table name, return the unqualified table name.
    `static int` | `getDecimalPortion(java.lang.String astrColumnHeader)` Return decimal portion of a decimal number
    `static char` | `getDecimalSeparator()` Get the decimal separator for the base locale (i.e., ENGLISH).
    `static char` | `getDecimalSeparator(java.util.Locale aLocale)` Get the decimal separator for the specified locale.
    `static java.io.File` | `getDirectoryPath(java.lang.String astrPath, java.lang.String astrClassName)` Given the fully-qualified path of a class name PLUS the class name, return the directory in which that class is located.
    `static java.lang.String` | `getEclipsePlatformPath(java.lang.String astrPathEMF)` Convert the given EMF Resource path to an Eclipse Platform IResource path.
    `static org.eclipse.emf.ecore.EObject` | `getEContainer(java.lang.Class aClassContainer, java.lang.Object aObjectContained)` Given an EMF object, traverse upwards through the containment hierarchy until an instance of the specified type is found; if so, return the instance of that type.
    `static org.eclipse.emf.common.util.URI` | `getEMFResourceURI(org.eclipse.emf.ecore.EObject aEObject)` Return the EMF URI of the supplied EObject instance, even if the object is a proxy.
    `static java.lang.String` | `getEMFVocabularyProxyName(org.eclipse.emf.ecore.ENamedElement aENamedElement)` Return the last node of the EMF Vocabulary proxy fragment from the supplied ENamedElement instance.
    `static java.lang.String` | `getEmptyAsNull(java.lang.Object aObjectInput)` If the specified input is `null` or empty when trimmed, this method will return `null`.
    `static java.lang.String` | `getEmptyString(java.lang.Object aObjectInput)` If the specified input is `null`, this method will return an empty string; otherwise, simply return the string value of the input.
    `static int` | `getIntegerFromProperties(java.lang.String astrPropertyName, int aiDefault)` Get the specified integer property.
    `static int` | `getIntegerPortion(java.lang.String astrColumnHeader)` Return integer portion of a decimal number
    `static java.io.File` | `getJarPath(java.lang.String astrPath)` Given the fully-qualified path of a Jar element, return a File instance of the Jar in which that element is contained.
    `static java.util.List` | `getListOfType(java.lang.Class aClass, java.util.List aList)` Given a heterogenous list of objects, return a list of only those objects of the specified type.
    `static java.lang.String` | `getLocalizedRuleID(java.lang.String astrRuleId, java.util.Locale aLocale)` Return a (possibly decimal) rule identifier localized in accord with the specified locale.
    `static java.lang.String` | `getLocationOfFile(java.lang.String astrResourceName, java.lang.ClassLoader aClassLoader)` Return the fully-qualified path name of a particular resource name, typically a java class name or a specialized "locator" name.
    `static java.lang.String` | `getNameOnly(java.lang.String astrName)` Return only the prefix prior to the "_" (dropping the suffix and underscore).
    `static java.lang.Object` | `getObjectInList(java.lang.Class aClass, java.util.List aList)` Returns the first instance of aClass found in aList.
    `static org.eclipse.emf.ecore.EObject` | `getProxyEquivalent(org.eclipse.emf.ecore.EObject aEObject)`
    `static java.lang.String` | `getQuotedValue(java.lang.String astrString)` Return the quoted value contained within apostrophes.
    `static org.eclipse.emf.ecore.resource.Resource` | `getResource(org.eclipse.emf.common.notify.Notification aNotification)` Given an EMF model notification, return the EMF resource that contains the notifier.
    `static java.lang.String` | `getServiceCalloutClassName(java.lang.String astrInput)` Return the Service Call-out class name from the specified string.
    `static java.lang.String` | `getServiceCalloutName(java.lang.String astrClassName, java.lang.String astrServiceName)` Return the Service Call-out class plus service name by concatenating the input parameter values.
    `static java.lang.String` | `getServiceCalloutServiceName(java.lang.String astrInput)` Return the Service Call-out service name from the specified string.
    `static char` | `getSetDelimiter()` Get the set delimiter for the base locale (i.e., ENGLISH).
    `static char` | `getSetDelimiter(java.util.Locale aLocale)` Get the set delimiter for the specified locale.
    `static java.lang.String` | `getSqlTypeName(java.lang.String astrSqlTypeName)` Given an SQL type of the form \(\), return only the \ portion.
    `static java.lang.String` | `getStringOrNull(java.lang.Object aObject)` Return either the toString of the specified object or `null` if the object is null.
    `static int` | `getSuffixOnly(java.lang.String astrName)` Return only the numeric suffix after the "_" or zero if none found.
    `static java.lang.Object` | `getValidDataValuePerDataType(java.lang.String astrDataType, java.lang.String astrDataValue, boolean abQuotes)` Method to check the data string value against the data type.
    `static java.util.List` | `insertBlankItem(java.util.List aList)` Insert a blank item into the beginning of the specified list.
    `static boolean` | `isClassInList(java.lang.Class aClass, java.util.List aList)` Returns `true` if at least one instance of class aClass can be found in aList.
    `static boolean` | `isDecimalColumn(java.lang.String astrColumnHeader)` Determine whether this is a decimal or integer column header.
    `static boolean` | `isEContainer(java.lang.Object aObjectContainer, java.lang.Object aObjectContained)` Determine whether one EMF object is a container of another, directly or indirectly.
    `static boolean` | `isFirstCharNumber(java.lang.String astrName)`
    `static boolean` | `isHeadless()` Are we running in headless mode (as foundation API only, without Eclipse IDE and workspace)?
    `static boolean` | `isIn(java.util.Vector avect, int ai)`
    `static boolean` | `isInteger(java.lang.String aString)`
    `static boolean` | `isJavaReservedWord(java.lang.String astrName)` Check to see if the String matches a Java Reserved Word.
    `static boolean` | `isLiteral(java.lang.String astrInput)` Determine whether the value is a string or date literal.
    `static boolean` | `isMyNotification(IModelAPI aIModelAPI, org.eclipse.emf.common.notify.Notification aNotification)` Given an API instance and a notification, return and indication of whether the notification pertains to the primary resource of the API (i.e., whether the notification came from that resource as opposed to some other resource.
    `static boolean` | `isMyNotificationBatch(IModelAPI aIModelAPI, NotificationBatch aNotificationBatch)` Given an API instance and a notification batch, return and indication of whether the notification batch pertains to the primary resource of the API (i.e., whether the notification came from that resource as opposed to some other resource.
    `static boolean` | `isMyNotificationInBatch(IModelAPI aIModelAPI, NotificationBatch aNotificationBatch)` Given an API instance and a notification batch, return and indication of whether the notification batch contains any resource that pertains the primary resource of the API (i.e., whether the notification came from that resource as opposed to some other resource.
    `static boolean` | `isSame(java.lang.Object ao1, java.lang.Object ao2)` Compare two objects and determine whether they are the equal.
    `static boolean` | `isSame(java.lang.String astrValue1, java.lang.String astrValue2, java.lang.String astrDataType, boolean abQuotedString)`
    `static boolean` | `isSameEmptyIsNull(java.lang.String astrStringOne, java.lang.String astrStringTwo)` Compare two strings and determine whether they are the equal, trimming the strings and treating empty string and null as equal.
    `static boolean` | `isSameIgnoreCase(java.lang.String astrStringOne, java.lang.String astrStringTwo)` Compare two strings and determine whether they are the equal, irrespective of case.
    `static boolean` | `isSet(org.eclipse.emf.ecore.EObject aEObject, org.eclipse.emf.ecore.EStructuralFeature aEStructuralFeature)` Determine whether the specified EMF object has an instance of the specified feature.
    `static boolean` | `isValid(java.lang.String astr)`
    `static boolean` | `isValidAlias(java.lang.String astrName)` Determine whether the specified alias is valid.
    `static boolean` | `isValidAssociationName(java.lang.String astrName)` Determine whether the specified association name is valid.
    `static boolean` | `isValidAttributeName(java.lang.String astrName)` Determine whether the specified attribute name is valid.
    `static boolean` | `isValidCustomDataTypeName(java.lang.String astrName)` Determine whether the specified custom data type name is valid.
    `static boolean` | `isValidDatabaseColumnName(java.lang.String astrColumnName)` Determine whether the specified database column name is valid.
    `static boolean` | `isValidDatabaseTableName(java.lang.String astrTableName)` Determine whether the specified database table name is valid.
    `static boolean` | `isValidDataValuePerDataType(java.lang.String astrDataType, java.lang.String astrDataValue, boolean abQuotes)` Method to check the data string value against the data type.
    `static boolean` | `isValidDomainName(java.lang.String astrName)` Determine whether the specified domain name is valid.
    `static boolean` | `isValidEntityName(java.lang.String astrName)` Determine whether the specified entity name is valid.
    `static boolean` | `isValidEnumerationLabel(java.lang.String astrName)` Determine whether the specified enumeration label name is valid.
    `static boolean` | `isValidFileName(java.lang.String astrFileName, java.lang.String astrFileExtension)`
    `static boolean` | `isValidName(java.lang.String astrName)` Determine whether the specified names meets some basic reasonableness criteria, such as non-null, non-blank, trimmed, no imbedded blanks, no unusual characters, and must begin with a letter.
    `static boolean` | `isValidName(java.lang.String astrName, boolean abDisallowNumbersAsFirstCharacter)` Determine whether the specified names meets some basic reasonableness criteria, such as non-null, non-blank, trimmed, no imbedded blanks, no unusual characters, and must begin with a letter.
    `static boolean` | `isValidName(java.lang.String astrName, java.lang.String astrCharactersAllowable, boolean abDisallowNumbersAsFirstCharacter)` Determine whether the specified names meets some basic reasonableness criteria, such as non-null, non-blank, trimmed, no imbedded blanks, no unusual characters, and must begin with a letter.
    `static boolean` | `isValidQuotedLiteral(java.lang.String astrLiteral)` Return `true` if the specified value is a properly quoted literal.
    `static boolean` | `isValidVocabularyReference(org.eclipse.emf.ecore.ENamedElement aENamedElement)` Return `true` if the specified Vocabulary reference is valid (i.e., points to an ENamedElement that still exists in the Vocabulary).
    `static boolean` | `isValidXMLName(java.lang.String astrName)` Return `true` if the specified name is a valid XML element (tag) name.
    `static int` | `parseInteger(java.lang.String astrInput)` Parse a string into an integer value.
    `static java.lang.String` | `removeSingleQuotesFromStartAndEnd(java.lang.String astrValue)` Removes single quotes from the beginning and end of the passed string.
    `static java.lang.String` | `replaceString(java.lang.String astrLookIn, java.lang.String astrLookFor, java.lang.String astrReplaceWith)`
    `static void` | `setAttribute(org.jdom.Element aNode, java.lang.String aAttribute, java.lang.String aValue)`
    `static java.lang.String` | `stripSpaces(java.lang.String astrInput)` Strip spaces from a value quickly and efficiently.
    `static java.lang.String` | `toHexString(byte[] abyInput)` Convert the supplied byte array into a String of hexadecimal digits.
    `static java.lang.String` | `trimDomain(java.lang.String astrFullyQualifiedEntityName)` Given a fully-qualified entity name, trim off the domain portion and return the unqualified entity name.
    `static java.lang.String` | `trimExtension(java.lang.String astrFileName)` Given a file name (or path) in string form, remove the file extension.
    `static java.lang.String` | `trimTrailingSpaces(java.lang.String astrValue)` Trim trailing spaces only.
    `static java.lang.String` | `trimURI(org.eclipse.emf.ecore.EObject aObject)` Trim URI for display, remove bookmarks
    `static void` | `unresolve(org.eclipse.emf.ecore.EObject aEObject)` Unresolve a given EObject.
    `static void` | `unresolveAll(org.eclipse.emf.ecore.EObject aEObject)` Unresolve a given EObject plus all of the objects it contains.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### CLASS_NAME_ARRAY_PREFIX

          public static final java.lang.String CLASS_NAME_ARRAY_PREFIX

      See Also:
        Constant Field Values

    - #### CLASS_NAME_ARRAY_SUFFIX

          public static final java.lang.String CLASS_NAME_ARRAY_SUFFIX

      See Also:
        Constant Field Values

    - #### NOT_REQUIRED_QUOTED_RESOURCES

          public static final java.util.List NOT_REQUIRED_QUOTED_RESOURCES

    - #### LOGICAL_ELEMENTS_LIST

          public static final java.util.List LOGICAL_ELEMENTS_LIST

  - ### Constructor Detail

    - #### CcUtil

          public CcUtil()

  - ### Method Detail

    - #### getNameOnly

          public static java.lang.String getNameOnly(java.lang.String astrName)

      Return only the prefix prior to the "_" (dropping the suffix and underscore).
      Parameters:
        `astrName` - Name with suffix (e.g., "age_1").
      Returns:
        Prefix only (e.g., "age").

    - #### getSuffixOnly

          public static int getSuffixOnly(java.lang.String astrName)

      Return only the numeric suffix after the "_" or zero if none found.
      Parameters:
        `astrName` - Name with suffix (e.g., "age_1").
      Returns:
        Numeric suffix as integer or zero if no suffix (or non-numeric).

    - #### getQuotedValue

          public static java.lang.String getQuotedValue(java.lang.String astrString)

      Return the quoted value contained within apostrophes.
      Parameters:
        `astrString` - Quoted string, typically a literal.
      Returns:
        Quoted value without delimiters.

    - #### isInteger

          public static boolean isInteger(java.lang.String aString)

    - #### isDecimalColumn

          public static boolean isDecimalColumn(java.lang.String astrColumnHeader)

      Determine whether this is a decimal or integer column header.
      Parameters:
        `column` - Column header string
      Returns:
        `true` if decimal header; otherwise return `false`

    - #### getIntegerPortion

          public static int getIntegerPortion(java.lang.String astrColumnHeader)

      Return integer portion of a decimal number
      Parameters:
        `column` - Column header string
      Returns:
        Integer portion of column header (int) or -1 if parse error occurs

    - #### getArrayClass

          public static java.lang.String getArrayClass(java.lang.String astrClassNameArray)

      Returns the "real" class name of an array class without the array prefix and suffix.
      Parameters:
        `astrClassNameArray` - Class name with array prefix and suffix.
        `astrClassName` - Class name without array prefix and suffix.
      Returns:
        Class name without array prefix and suffix.

    - #### getBooleanFromProperties

          public static boolean getBooleanFromProperties(java.lang.String astrPropertyName,
                                         boolean abDefault)

      Get the specified boolean property.
      Parameters:
        `astrPropertyName` - Property name.
        `abDefault` - Default value.
      Returns:
        `true` if property is String "true".

    - #### getIntegerFromProperties

          public static int getIntegerFromProperties(java.lang.String astrPropertyName,
                                     int aiDefault)

      Get the specified integer property.
      Parameters:
        `astrPropertyName` - Property name.
        `aiDefault` - Default value.
      Returns:
        Integer value or -1 if not specified.

    - #### getCustomDataTypeName

          public static java.lang.String getCustomDataTypeName(java.lang.String astrCustomDataTypeReference)

      Given a custom data type reference (e.g., "ShirtSize#Small"), return the custom data type portion (e.g., "ShirtSize").
      Parameters:
        `astrCustomDataTypeReference` - Custom data type reference.
      Returns:
        Custom data type name or `null`.

    - #### getCustomDataTypeEnumerationLabel

          public static java.lang.String getCustomDataTypeEnumerationLabel(java.lang.String astrCustomDataTypeReference)

      Given a custom data type reference (e.g., "ShirtSize#Small"), return the enumeration label portion (e.g., "Small").
      Parameters:
        `astrCustomDataTypeReference` - Custom data type reference.
      Returns:
        Enumeration label or `null`.

    - #### getDatabaseFullyQualifiedName

          public static java.lang.String getDatabaseFullyQualifiedName(java.lang.String astrCatalog,
                                                       java.lang.String astrSchema,
                                                       java.lang.String astrTable)

      Return a fully-qualified database table name given optional catalog, schema and table name.
      Parameters:
        `astrCatalog` - Optional catalog name.
        `astrSchema` - Optional schema name.
        `astrTable` - Optional table name.

    - #### getDatabaseCatalogName

          public static java.lang.String getDatabaseCatalogName(java.lang.String astrFullyQualifiedTableName)

      Given fully-qualified table name, return the catalog name.
      Parameters:
        `astrFullyQualifiedTableName` - Fully-qualified table name.
      Returns:
        Catalog name.

    - #### getDatabaseSchemaName

          public static java.lang.String getDatabaseSchemaName(java.lang.String astrFullyQualifiedTableName)

      Given fully-qualified table name, return the schema name.
      Parameters:
        `astrFullyQualifiedTableName` - Fully-qualified table name.
      Returns:
        Schema name.

    - #### getDatabaseTableName

          public static java.lang.String getDatabaseTableName(java.lang.String astrFullyQualifiedTableName)

      Given fully-qualified table name, return the unqualified table name.
      Parameters:
        `astrFullyQualifiedTableName` - Fully-qualified table name.
      Returns:
        Unqualified table name.

    - #### getDecimalPortion

          public static int getDecimalPortion(java.lang.String astrColumnHeader)

      Return decimal portion of a decimal number
      Parameters:
        `column` - Column header string
      Returns:
        Decimal portion of column header (int) or -1 if parse error occurs

    - #### isValid

          public static boolean isValid(java.lang.String astr)

    - #### isValidFileName

          public static boolean isValidFileName(java.lang.String astrFileName,
                                java.lang.String astrFileExtension)

    - #### isIn

          public static boolean isIn(java.util.Vector avect,
                     int ai)

    - #### isValidDomainName

          public static boolean isValidDomainName(java.lang.String astrName)

      Determine whether the specified domain name is valid.
      Parameters:
        `astrName` - to test.
      Returns:
        `true` if name id valid.

    - #### isValidEntityName

          public static boolean isValidEntityName(java.lang.String astrName)

      Determine whether the specified entity name is valid.
      Parameters:
        `astrName` - to test.
      Returns:
        `true` if name id valid.

    - #### isValidAttributeName

          public static boolean isValidAttributeName(java.lang.String astrName)

      Determine whether the specified attribute name is valid.
      Parameters:
        `astrName` - to test.
      Returns:
        `true` if name id valid.

    - #### isValidAssociationName

          public static boolean isValidAssociationName(java.lang.String astrName)

      Determine whether the specified association name is valid.
      Parameters:
        `astrName` - to test.
      Returns:
        `true` if name id valid.

    - #### isValidCustomDataTypeName

          public static boolean isValidCustomDataTypeName(java.lang.String astrName)

      Determine whether the specified custom data type name is valid.
      Parameters:
        `astrName` - to test.
      Returns:
        `true` if name id valid.

    - #### isValidEnumerationLabel

          public static boolean isValidEnumerationLabel(java.lang.String astrName)

      Determine whether the specified enumeration label name is valid.
      Parameters:
        `astrName` - to test.
      Returns:
        `true` if name id valid.

    - #### isValidDatabaseTableName

          public static boolean isValidDatabaseTableName(java.lang.String astrTableName)

      Determine whether the specified database table name is valid.
      Parameters:
        `astrTableName` - Database table name.
      Returns:
        `true` if database table name is valid.

    - #### isValidDatabaseColumnName

          public static boolean isValidDatabaseColumnName(java.lang.String astrColumnName)

      Determine whether the specified database column name is valid.
      Parameters:
        `astrColumnName` - Database column name.
      Returns:
        `true` if database column name is valid.

    - #### isValidName

          public static boolean isValidName(java.lang.String astrName)

      Determine whether the specified names meets some basic reasonableness criteria, such as non-null, non-blank, trimmed, no imbedded blanks, no unusual characters, and must begin with a letter. This overload supplies the default allowable character array.
      Parameters:
        `astrName` - Name
      Returns:
        `true` if the name is valid

    - #### isValidName

          public static boolean isValidName(java.lang.String astrName,
                            boolean abDisallowNumbersAsFirstCharacter)

      Determine whether the specified names meets some basic reasonableness criteria, such as non-null, non-blank, trimmed, no imbedded blanks, no unusual characters, and must begin with a letter. This overload supplies the default allowable character array.
      Parameters:
        `astrName` - Name
      Returns:
        `true` if the name is valid

    - #### isValidName

          public static boolean isValidName(java.lang.String astrName,
                            java.lang.String astrCharactersAllowable,
                            boolean abDisallowNumbersAsFirstCharacter)

      Determine whether the specified names meets some basic reasonableness criteria, such as non-null, non-blank, trimmed, no imbedded blanks, no unusual characters, and must begin with a letter.
      Parameters:
        `astrName` - Name
        `astrCharactersAllowable` - List of allowable characters
        `abLeadingAlphaCheck` - Ensure that first character is alphabetic character
      Returns:
        `true` if the name is valid

    - #### isFirstCharNumber

          public static boolean isFirstCharNumber(java.lang.String astrName)

    - #### isValidQuotedLiteral

          public static boolean isValidQuotedLiteral(java.lang.String astrLiteral)

      Return `true` if the specified value is a properly quoted literal.
      Parameters:
        `astrLiteral` - Literal enclosed in apostrophes.
      Returns:
        `true` if the specified value is a properly quoted literal.

    - #### isValidDataValuePerDataType

          public static boolean isValidDataValuePerDataType(java.lang.String astrDataType,
                                            java.lang.String astrDataValue,
                                            boolean abQuotes)

      Method to check the data string value against the data type.
      Parameters:
        `astrDataType` - String Data type (e.g., Constants.UI_TYPE_DECIMAL).
        `astrDataValue` - Value to be tested.
        `abQuotes` - `true` if String and Date values are to be supplied with apostrophes.
      Returns:
        `true` if user data is of valid with respect to type, else `false`

    - #### getValidDataValuePerDataType

          public static java.lang.Object getValidDataValuePerDataType(java.lang.String astrDataType,
                                                      java.lang.String astrDataValue,
                                                      boolean abQuotes)

      Method to check the data string value against the data type.
      Parameters:
        `astrDataType` - String Data type (e.g., Constants.UI_TYPE_DECIMAL).
        `astrDataValue` - Value to be tested.
        `abQuotes` - `true` if String and Date values are to be supplied with apostrophes.
      Returns:
        `true` if user data is of valid with respect to type, else `false`

    - #### isValidXMLName

          public static boolean isValidXMLName(java.lang.String astrName)

      Return `true` if the specified name is a valid XML element (tag) name.
      Parameters:
        `astrName` - XML element name.
      Returns:
        `true` if the specified name is a valid XML element (tag) name.

    - #### isValidAlias

          public static boolean isValidAlias(java.lang.String astrName)

      Determine whether the specified alias is valid.
      Parameters:
        `astrName` - to test.
      Returns:
        `true` if name id valid.

    - #### isValidVocabularyReference

          public static boolean isValidVocabularyReference(org.eclipse.emf.ecore.ENamedElement aENamedElement)

      Return `true` if the specified Vocabulary reference is valid (i.e., points to an ENamedElement that still exists in the Vocabulary). System-wide protocol for Vocabulary deletion involves the conversion of any existing cross-references back to unresolved proxies. This means that a Vocabulary reference should either be a proxy or a valid reference. As long as this contract holds true, this test is extremely simple.
      Parameters:
        `aENamedElement` - Named element from Vocabulary.
      Returns:
        `true` if Vocabulary element exists in Vocabulary.

    - #### replaceString

          public static java.lang.String replaceString(java.lang.String astrLookIn,
                                       java.lang.String astrLookFor,
                                       java.lang.String astrReplaceWith)

    - #### stripSpaces

          public static java.lang.String stripSpaces(java.lang.String astrInput)

      Strip spaces from a value quickly and efficiently.
      Parameters:
        `astrInput` - Input to strip.
      Returns:
        Value without spaces.

    - #### isSame

          public static boolean isSame(java.lang.Object ao1,
                       java.lang.Object ao2)

      Compare two objects and determine whether they are the equal. This differs from the Object's "equals" method in that it will return true if both Strings are null.
      Parameters:
        `ao1` - Object one
        `ao2` - Object two
      Returns:
        `true` if strings are identical

    - #### isSame

          public static boolean isSame(java.lang.String astrValue1,
                       java.lang.String astrValue2,
                       java.lang.String astrDataType,
                       boolean abQuotedString)

    - #### isSameIgnoreCase

          public static boolean isSameIgnoreCase(java.lang.String astrStringOne,
                                 java.lang.String astrStringTwo)

      Compare two strings and determine whether they are the equal, irrespective of case. This differs from the String "equals" method in that it will return true if both Strings are null.
      Parameters:
        `astrStringOne` - String one.
        `astrStringTwo` - String two.
      Returns:
        `true` if strings are identical ignoring case.

    - #### isSet

          public static boolean isSet(org.eclipse.emf.ecore.EObject aEObject,
                      org.eclipse.emf.ecore.EStructuralFeature aEStructuralFeature)

      Determine whether the specified EMF object has an instance of the specified feature.
      Parameters:
        `aEObject` - EObject to be tested.
        `aEStructuralFeature` - EStructuralFeature to be tested.
      Returns:
        `true` if the object has any cross references.

    - #### isLiteral

          public static boolean isLiteral(java.lang.String astrInput)

      Determine whether the value is a string or date literal. This is defined as beginning and ending with single quote.
      Parameters:
        `astrInput` - String to test.
      Returns:
        `true` if string is a literal.

    - #### isSameEmptyIsNull

          public static boolean isSameEmptyIsNull(java.lang.String astrStringOne,
                                  java.lang.String astrStringTwo)

      Compare two strings and determine whether they are the equal, trimming the strings and treating empty string and null as equal.
      Parameters:
        `astrStringOne` - String one
        `astrStringTwo` - String two
      Returns:
        `true` if strings are identical

    - #### getEmptyAsNull

          public static java.lang.String getEmptyAsNull(java.lang.Object aObjectInput)

      If the specified input is `null` or empty when trimmed, this method will return `null`. otherwise, it will simply return the trimmed input value.
      Parameters:
        `aObjectInput` - Object input.
      Returns:
        String value of object or `null` if input is empty when trimmed.

    - #### getEmptyString

          public static java.lang.String getEmptyString(java.lang.Object aObjectInput)

      If the specified input is `null`, this method will return an empty string; otherwise, simply return the string value of the input.
      Parameters:
        `aObjectInput` - Object input.
      Returns:
        String value of object or empty string ("") if input is `null`.

    - #### getStringOrNull

          public static java.lang.String getStringOrNull(java.lang.Object aObject)

      Return either the toString of the specified object or `null` if the object is null.
      Returns:
        String value of object or `null`.

    - #### decapitalize

          public static java.lang.String decapitalize(java.lang.String astrString)

      Trim and decapitalize a string (i.e., make the first character lowercase).
      Parameters:
        `astrStringOne` - String to decapitalize.
      Returns:
        String with first character in lowercase.

    - #### debugStackTrace

          public static void debugStackTrace()

      Handy method to generate a stack trace.

    - #### capitalize

          public static java.lang.String capitalize(java.lang.String astrString)

      Trim and capitalize a string (i.e., make the first character uppercase).
      Parameters:
        `astrStringOne` - String to decapitalize
      Returns:
        String with first character in uppercase

    - #### calculateOverlap

          public static int calculateOverlap(int aiBeginOne,
                             int aiEndOne,
                             int aiBeginTwo,
                             int aiEndTwo)

      Calculate the overlap between two ranges of values. This method will return zero of there is no overlap between the two ranges.
      Parameters:
        `aiBeginOne` - Starting value one.
        `aiEndOne` - Ending value one.
        `aiBeginTwo` - Starting value two.
        `aiEndTwo` - Ending value two.
      Returns:
        Integer representing overlapping range.

    - #### isJavaReservedWord

          public static boolean isJavaReservedWord(java.lang.String astrName)

      Check to see if the String matches a Java Reserved Word. Note: This function was originally used to validate Rulesheet names, but some programming changes have eliminated this requirement.
      Parameters:
        `astrName` - String to test
      Returns:
        `true` if the String matches a Java reserved word

    - #### containsBlanks

          public static boolean containsBlanks(java.lang.String astrString)

      Determine whether the specified string contains any blanks.
      Parameters:
        `astrString` - String to test
      Returns:
        `true` if the string contains one or more blanks

    - #### containsAllowableCharacters

          public static boolean containsAllowableCharacters(java.lang.String astrString,
                                            java.lang.String astrCharactersAllowable)

      Determine whether the specified string contains allowable characters
      Parameters:
        `astrString` - String to test
        `astrCharactersAllowable` - List of allowable characters
      Returns:
        `true` if the string contains allowable characters

    - #### parseInteger

          public static int parseInteger(java.lang.String astrInput)

      Parse a string into an integer value. If the String is `null` or non-numeric, return -1.
      Parameters:
        `astrInput` - Input string containing purported integer value.
      Returns:
        Integer value or -1.

    - #### escapeUnicodeString

          public static java.lang.String escapeUnicodeString(java.lang.String astrInput,
                                             boolean abEscapeAscii)

      Given a Unicode string, display the hexadecimal Unicode values. Characters within the ASCII range may be either formatted as hexadecimal or simply presented as characters based on the value of ababEscapeAscii.
      Parameters:
        `astrInput` - Input string
        `ababEscapeAscii` - Format all characters (even US-ASCII)

    - #### toHexString

          public static java.lang.String toHexString(byte[] abyInput)

      Convert the supplied byte array into a String of hexadecimal digits.
      Parameters:
        `abyInput` - Input byte array
      Returns:
        String of hexadecimal digits

    - #### getDecimalSeparator

          public static char getDecimalSeparator()

      Get the decimal separator for the base locale (i.e., ENGLISH).
      Returns:
        Separator character.

    - #### getDecimalSeparator

          public static char getDecimalSeparator(java.util.Locale aLocale)

      Get the decimal separator for the specified locale.
      Parameters:
        `aLocale` - Locale for which decimal separator is to be returned.
      Returns:
        Separator character.

    - #### getSetDelimiter

          public static char getSetDelimiter()

      Get the set delimiter for the base locale (i.e., ENGLISH).
      Returns:
        Set delimiter.

    - #### getSetDelimiter

          public static char getSetDelimiter(java.util.Locale aLocale)

      Get the set delimiter for the specified locale.
      Parameters:
        `aLocale` - Locale for which set delimiter is to be returned.
      Returns:
        Set delimiter.

    - #### getSqlTypeName

          public static java.lang.String getSqlTypeName(java.lang.String astrSqlTypeName)

      Given an SQL type of the form \(\), return only the \ portion. Example input TIMESTAMP(6) returns just TIMESTAMP.
      Parameters:
        `SQL` - Type name optionally with modifier.
      Returns:
        SQL Type name without modifier.

    - #### getServiceCalloutClassName

          public static java.lang.String getServiceCalloutClassName(java.lang.String astrInput)

      Return the Service Call-out class name from the specified string.
      Parameters:
        `astrInput` - Input string.
      Returns:
        Service Call-out Class Name.

    - #### getServiceCalloutServiceName

          public static java.lang.String getServiceCalloutServiceName(java.lang.String astrInput)

      Return the Service Call-out service name from the specified string.
      Parameters:
        `astrInput` - Input string.
      Returns:
        Service Call-out service name.

    - #### getServiceCalloutName

          public static java.lang.String getServiceCalloutName(java.lang.String astrClassName,
                                               java.lang.String astrServiceName)

      Return the Service Call-out class plus service name by concatenating the input parameter values.
      Parameters:
        `astrClassName` - Class name.
        `astrServiceName` - Service name.
      Returns:
        Class plus service name.

    - #### createValueSetFromString

          public static ValueSet createValueSetFromString(java.lang.String astrInput)

      Create a new instance of ValueSet from a string in set notation.
      Parameters:
        `astrInput` - Input string in set notation.
      Returns:
        ValueSet instance.

    - #### convertValueSetToString

          public static java.lang.String convertValueSetToString(java.lang.Object aObject)

      Convert a ValueSet instance to a string in set notation.
      Parameters:
        `aValueSet` - ValueSet instance.
      Returns:
        String set notation or empty string if ValueSet is null.

    - #### convertEscapeToSpace

          public static java.lang.String convertEscapeToSpace(java.lang.String astrInput)

      Convert Java escape characters such as carriage return and line feed to spaces.
      Parameters:
        `astrInput` - Input to be converted.
      Returns:
        Input with escape characters converted to spaces.

    - #### isClassInList

          public static boolean isClassInList(java.lang.Class aClass,
                              java.util.List aList)

      Returns `true` if at least one instance of class aClass can be found in aList.
      Parameters:
        `aClass` - Class to locate.
        `aList` - List of objects to search.
      Returns:
        `true` if at least one instance of the specified class is in the list.

    - #### getObjectInList

          public static java.lang.Object getObjectInList(java.lang.Class aClass,
                                         java.util.List aList)

      Returns the first instance of aClass found in aList.
      Parameters:
        `aClass` - Class to locate.
        `aList` - List of objects to search.
      Returns:
        First instance of aClass located in aList or `null`.

    - #### getListOfType

          public static java.util.List getListOfType(java.lang.Class aClass,
                                     java.util.List aList)

      Given a heterogenous list of objects, return a list of only those objects of the specified type.
      Parameters:
        `aClass` - Class to locate.
        `aList` - List of objects of that type.
        `List` - of all instances of the specified type.

    - #### getLocalizedRuleID

          public static java.lang.String getLocalizedRuleID(java.lang.String astrRuleId,
                                            java.util.Locale aLocale)

      Return a (possibly decimal) rule identifier localized in accord with the specified locale. This is often a matter of replacing the decimal point with a comma.
      Parameters:
        `astrRuleId` - Rule ID in base form.
        `aLocale` - Locale in which Rule ID should be returned.
      Returns:
        Localized Rule ID (may be same as input in many locales).

    - #### getBaseRuleID

          public static java.lang.String getBaseRuleID(java.lang.String astrRuleId,
                                       java.util.Locale aLocale)

      Given a localized Rule ID expressed in a particular locale, return the corresponding base ID. This is a matter of simply replacing the decimal separator with a period.
      Parameters:
        `astrRuleId` - Rule ID in localized form.
        `aLocale` - Locale in which Rule ID is expressed.
      Returns:
        Base rule ID.

    - #### getEContainer

          public static org.eclipse.emf.ecore.EObject getEContainer(java.lang.Class aClassContainer,
                                                    java.lang.Object aObjectContained)

      Given an EMF object, traverse upwards through the containment hierarchy until an instance of the specified type is found; if so, return the instance of that type.
      Parameters:
        `aClassContainer` - Class of container to locate
        `EObjectContained` - Contained EMF object.
      Returns:
        Instance of specified container class or `null` if none.

    - #### isEContainer

          public static boolean isEContainer(java.lang.Object aObjectContainer,
                             java.lang.Object aObjectContained)

      Determine whether one EMF object is a container of another, directly or indirectly.
      Parameters:
        `aObjectContainer` - EObject container.
        `aObjectContained` - EObject contained.
      Returns:
        `true` if first parameter contains the second.

    - #### getEclipsePlatformPath

          public static java.lang.String getEclipsePlatformPath(java.lang.String astrPathEMF)

      Convert the given EMF Resource path to an Eclipse Platform IResource path. For example: platform:/resource/project/file.xyz -> /project/file.xyz
      Parameters:
        `astrPathEMF` - EMF path.
      Returns:
        Eclipse Platform path or `null` for invalid EMF path.

    - #### getEMFResourceURI

          public static org.eclipse.emf.common.util.URI getEMFResourceURI(org.eclipse.emf.ecore.EObject aEObject)

      Return the EMF URI of the supplied EObject instance, even if the object is a proxy.
      Parameters:
        `aEObject` - EObject whose resource URI is to be returned.
      Returns:
        EMF Resource URI object.

    - #### getEMFVocabularyProxyName

          public static java.lang.String getEMFVocabularyProxyName(org.eclipse.emf.ecore.ENamedElement aENamedElement)

      Return the last node of the EMF Vocabulary proxy fragment from the supplied ENamedElement instance.
      Parameters:
        `aENamedElement` - ENamedElement whose base name is to be returned.
      Returns:
        Last node (leaf-level node) of the URI fragment.
      Throws:
        `java.lang.IllegalArgumentException` - if EObject is not a proxy.

    - #### findResource

          public static org.eclipse.core.resources.IResource findResource(org.eclipse.emf.ecore.EObject aEObject)

      Retrieve the Eclipse platform Resource (IResource) corresponding to the specified EMF object.
      Parameters:
        `aEObject` - EObject instance.
      Returns:
        Eclipse platform resource.

    - #### findResource

          public static org.eclipse.core.resources.IResource findResource(org.eclipse.emf.common.util.URI aURI)

      Find resource in workspace given a URI. The URI may either be platform relative with "platform" protocol, or may be a fully-qualified URI including "file" protocol.
      Parameters:
        `aURI` - URI whose resource should be found.
      Returns:
        IResource representing resource in Eclipse.

    - #### formatCustomDataType

          public static java.lang.String formatCustomDataType(java.lang.String astrCustomDataTypeName,
                                              java.lang.String astrEnumerationLabel)

      Format and return a custom data type reference given a name and enumeration label
      Parameters:
        `astrCustomDataTypeName` - Custom data type name.
        `astrEnumerationLabel` - Enumeration label.
      Returns:
        Formatted custom data type name (e.g., "ShirtSize#Small").

    - #### formatValueSetString

          public static java.lang.String formatValueSetString(java.lang.String astrSet,
                                              java.util.Locale aLocale,
                                              boolean abAvoidQuotingKeywords)

      Given a caller-supplied set in standard notation, add apostrophes (single quotes) if necessary. The braces are not returned.
      Parameters:
        `astrSet` - Input set in localized form.
        `aLocale` - in which input set is expressed.
        `abAvoidQuotingKeywords` - `true` to avoid quoting keywords like `null`.
      Returns:
        Set with apostrophes around each element (if not already present).

    - #### insertBlankItem

          public static java.util.List insertBlankItem(java.util.List aList)

      Insert a blank item into the beginning of the specified list. This method can be used to prepare lists for use by combo boxes, where the first row is blank, allowing the user "clear out" a previously entered value.
      Parameters:
        `aList` - List to be updated (in place).
      Returns:
        List with additional blank row at the beginning.

    - #### exists

          public static boolean exists(org.eclipse.emf.ecore.EObject aEObject)

      Does this EObject exist with given URI?
      Parameters:
        `aEObject` - EObject to test.
      Returns:
        `true` if the object exists.

    - #### isHeadless

          public static boolean isHeadless()

      Are we running in headless mode (as foundation API only, without Eclipse IDE and workspace)?
      Returns:
        true if headless

    - #### exists

          public static boolean exists(org.eclipse.emf.common.util.URI aURI)

      Does object pointed to by the URI exist?
      Parameters:
        `aURI` - URI to test.
      Returns:
        `true` if URI exists.

    - #### trimTrailingSpaces

          public static java.lang.String trimTrailingSpaces(java.lang.String astrValue)

      Trim trailing spaces only. If there is nothing but white space, or the string is empty, return empty string.
      Parameters:
        `astrValue` - Value to be stripped.
      Returns:
        Value without trailing spaces.

    - #### trimURI

          public static java.lang.String trimURI(org.eclipse.emf.ecore.EObject aObject)

      Trim URI for display, remove bookmarks
      Parameters:
        `aObject` -
      Returns:

    - #### convertPlatformURIToFilePath

          public static java.lang.String convertPlatformURIToFilePath(java.lang.String astrURI)

      Convert platform URI to file path, e.g. platform:/resource/Test/aaa to c:/eclipse/workspace/Test/aaa
      Parameters:
        `astrURI` -
      Returns:

    - #### convertFileURIToFilePath

          public static java.lang.String convertFileURIToFilePath(java.lang.String lstrResult)

      Convert file URI to file path, e.g. file:/c:/windows to c:/windows
      Parameters:
        `lstrResult` -
      Returns:

    - #### convertPathToRelative

          public static java.lang.String convertPathToRelative(java.lang.String astrPathInput)

      Convert the specified absolute path to Eclipse workspace-relative. There is probably a utility method somewhere in Eclipse to do this, but such a method could not be found. It might be advantageous to move this into UiUtil.
      Parameters:
        `astrPathInput` - Absolute path (including drive letter).
      Returns:
        Eclipse Workspace-relative path.

    - #### getResource

          public static org.eclipse.emf.ecore.resource.Resource getResource(org.eclipse.emf.common.notify.Notification aNotification)

      Given an EMF model notification, return the EMF resource that contains the notifier.
      Parameters:
        `aNotification` - EMF model notification.
      Returns:
        Resource affected or `null`.

    - #### isMyNotification

          public static boolean isMyNotification(IModelAPI aIModelAPI,
                                 org.eclipse.emf.common.notify.Notification aNotification)

      Given an API instance and a notification, return and indication of whether the notification pertains to the primary resource of the API (i.e., whether the notification came from that resource as opposed to some other resource.
      Parameters:
        `aIModelAPI` - Model API instance.
        `aNotification` - EMF model notification.
      Returns:
        `true` if notification comes from the specified API.

    - #### isMyNotificationBatch

          public static boolean isMyNotificationBatch(IModelAPI aIModelAPI,
                                      NotificationBatch aNotificationBatch)

      Given an API instance and a notification batch, return and indication of whether the notification batch pertains to the primary resource of the API (i.e., whether the notification came from that resource as opposed to some other resource.
      Parameters:
        `aIModelAPI` - Model API instance.
        `aNotificationBatch` - Notification batch instance.
      Returns:
        `true` if notification comes from the specified API.

    - #### isMyNotificationInBatch

          public static boolean isMyNotificationInBatch(IModelAPI aIModelAPI,
                                        NotificationBatch aNotificationBatch)

      Given an API instance and a notification batch, return and indication of whether the notification batch contains any resource that pertains the primary resource of the API (i.e., whether the notification came from that resource as opposed to some other resource.
      Parameters:
        `aIModelAPI` - Model API instance.
        `aNotificationBatch` - Notification batch instance.
      Returns:
        `true` if notification comes from the specified API.

    - #### removeSingleQuotesFromStartAndEnd

          public static java.lang.String removeSingleQuotesFromStartAndEnd(java.lang.String astrValue)

      Removes single quotes from the beginning and end of the passed string.
      Parameters:
        `astrValue` - Original string with the single quote at then beginning and end.
      Returns:
        String after removing single quote.

    - #### cloneEObject

          public static org.eclipse.emf.ecore.EObject cloneEObject(org.eclipse.emf.ecore.EObject aEObject,
                                                   boolean abUnresolve)

      Create a deep clone of the specified EMF object. The object and all of its children will be cloned, effectively returning a tree of objects. As a convenience, all of the cross-references in the returned object will be unresolved. This makes is convenient for use in cut/copy/paste to clipboard.
      Parameters:
        `aEObject` - EObject to be cloned.
        `abUnresolve` - `true` to unresolve proxies.
      Returns:
        Cloned EObject (full containment hierarchy).

    - #### exceptionToString

          public static java.lang.String exceptionToString(java.lang.Throwable aThrowable)

      Convert an exception or error stack trace to string form.
      Parameters:
        `aThrowable` - Error or exception.
      Returns:
        String version of stack trace.

    - #### getLocationOfFile

          public static java.lang.String getLocationOfFile(java.lang.String astrResourceName,
                                           java.lang.ClassLoader aClassLoader)

      Return the fully-qualified path name of a particular resource name, typically a java class name or a specialized "locator" name.
      Parameters:
        `astrResourceName` - Resource name to find.
        `aClassLoader` - ClassLoader to use for resource lookup.
      Returns:
        Fully-qualified path name of JAR or directory.

    - #### getJarPath

          public static java.io.File getJarPath(java.lang.String astrPath)

      Given the fully-qualified path of a Jar element, return a File instance of the Jar in which that element is contained. Examples: file:/C:/CcVersion50/Corticon_Eclipse/com.corticon.legacy/lib/ant-launcher.jar!/org/apache/tools/ant/launch/Launcher.class C:/CcVersion50/Corticon_Eclipse/com.corticon.legacy/lib/ant-launcher.jar!/org/apache/tools/ant/launch/Launcher.class
      Parameters:
        `astrPath` - Path name of Jar element.
      Returns:
        File instance corresponding to Jar.

    - #### getDirectoryPath

          public static java.io.File getDirectoryPath(java.lang.String astrPath,
                                      java.lang.String astrClassName)

      Given the fully-qualified path of a class name PLUS the class name, return the directory in which that class is located. C:/CcVersion50/Corticon_Eclipse/com.corticon.cdobuilder/bin/com/corticon/cdobuilder/CcCDOUtils.class
      Parameters:
        `astrPath` - File path.
        `astrClassName` - Class name.
      Returns:
        File instance corresponding to directory within which class resides.

    - #### trimExtension

          public static java.lang.String trimExtension(java.lang.String astrFileName)

      Given a file name (or path) in string form, remove the file extension.
      Parameters:
        `astrFileName` - File name to be used.
      Returns:
        File name without extension.

    - #### trimDomain

          public static java.lang.String trimDomain(java.lang.String astrFullyQualifiedEntityName)

      Given a fully-qualified entity name, trim off the domain portion and return the unqualified entity name.
      Parameters:
        `astrInput` - Fully-qualified entity name.
      Returns:
        Unqualified entity name.

    - #### unresolve

          public static void unresolve(org.eclipse.emf.ecore.EObject aEObject)

      Unresolve a given EObject. Any cross-document references found in the EObject will be converted to unresolved proxies.
      Parameters:
        `aEObject` - EObject (root) to unresolve.

    - #### getProxyEquivalent

          public static org.eclipse.emf.ecore.EObject getProxyEquivalent(org.eclipse.emf.ecore.EObject aEObject)

    - #### unresolveAll

          public static void unresolveAll(org.eclipse.emf.ecore.EObject aEObject)

      Unresolve a given EObject plus all of the objects it contains. Any cross-document references found in the EObject and its children will be converted to unresolved proxies.
      Parameters:
        `aEObject` - EObject (root) to unresolve.

    - #### fromDateToString

          public static java.lang.String fromDateToString(java.util.Date aDate)

    - #### setAttribute

          public static void setAttribute(org.jdom.Element aNode,
                          java.lang.String aAttribute,
                          java.lang.String aValue)

    - #### addChild

          public static org.jdom.Element addChild(org.jdom.Element aParent,
                                  java.lang.String aName)

    - #### addChild

          public static org.jdom.Element addChild(org.jdom.Element aParent,
                                  java.lang.String aName,
                                  java.lang.String aValue)

    - #### addChild

          public static org.jdom.Element addChild(org.jdom.Element aParent,
                                  java.lang.String aNodeName,
                                  java.lang.String aAttributeName,
                                  java.lang.String aAttributeValue)

    - #### determineCommonRoot

          public static java.lang.String determineCommonRoot(java.util.List<java.lang.String> alstFilePaths)

    - #### generateHibernateUserFriendlyExceptionMessage

          public static java.lang.String generateHibernateUserFriendlyExceptionMessage(java.lang.Throwable aThrowable)

Copyright © 2005-2013 Progress Software Corporation and/or its subsidiaries and affiliates. All rights reserved.